package com.keao.alimeeting.detail

import android.support.annotation.CallSuper
import java.lang.ref.WeakReference

open class RxPresenter<V> {
    private var view: WeakReference<V>? = null

    val isViewAttached: Boolean
        get() = view != null && view!!.get() != null

    @CallSuper
    fun onViewAttached(view: V) {
        this.view = WeakReference(view)
    }

    @CallSuper
    fun onViewDetached() {
        view = null
    }


    fun getView(): V? {
        return if (view == null) null else view!!.get()
    }

    @CallSuper
    open fun onDestroyed() {
    }

}