package com.keao.alimeeting.widget;

import android.graphics.Rect;
import android.support.v7.widget.RecyclerView;
import android.view.View;

/**
 * Created by zhiqian on 2016/10/24.
 */

public class GridItemDecoration extends RecyclerView.ItemDecoration {

    private int mGridSpacePx;
    private int mGridSize;
    private boolean mNeedLeftSpacing = false;

    public GridItemDecoration(int gridSpace, int gridSize) {
        mGridSpacePx = gridSpace;
        mGridSize = gridSize;
    }

    public void setGridSize(int gridSize) {
        mGridSize = gridSize;
    }

    @Override
    public void getItemOffsets(Rect outRect, View view, RecyclerView parent, RecyclerView.State state) {
        int frameWidth = (int) ((parent.getWidth() - (float) mGridSpacePx * (mGridSize - 1)) / mGridSize);
        int padding = parent.getWidth() / mGridSize - frameWidth;
        int itemPositon = ((RecyclerView.LayoutParams) view.getLayoutParams()).getViewAdapterPosition();
        if (itemPositon < mGridSize) {
            outRect.top = 0;
        } else {
            outRect.top = mGridSpacePx;
        }

        if (itemPositon % mGridSize == 0) {
            outRect.left = 0;
            outRect.right = padding;
            mNeedLeftSpacing = true;
        } else if((itemPositon + 1) % mGridSize == 0){
            mNeedLeftSpacing = false;
            outRect.right = 0;
            outRect.left = padding;
        }else if(mNeedLeftSpacing){
            outRect.left = mGridSpacePx - padding;
            if ((itemPositon + 2) % mGridSize == 0) {
                outRect.right = mGridSpacePx - padding;
            } else {
                outRect.right = mGridSpacePx / 2;
            }
        }else if ((itemPositon + 2) % mGridSize == 0) {
            mNeedLeftSpacing = false;
            outRect.left = mGridSpacePx / 2;
            outRect.right = mGridSpacePx - padding;
        } else {
            mNeedLeftSpacing = false;
            outRect.left = mGridSpacePx / 2;
            outRect.right = mGridSpacePx / 2;
        }
        outRect.bottom = 0;
    }
}
